package org.dromara.system.service.impl;

import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Service;
import org.dromara.system.domain.bo.SiteCompanycodeBo;
import org.dromara.system.domain.vo.SiteCompanycodeVo;
import org.dromara.system.domain.SiteCompanycode;
import org.dromara.system.mapper.SiteCompanycodeMapper;
import org.dromara.system.service.ISiteCompanycodeService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 【请填写功能名称】Service业务层处理
 *
 * @author Lion Li
 * @date 2024-10-31
 */
@RequiredArgsConstructor
@Service
public class SiteCompanycodeServiceImpl implements ISiteCompanycodeService {

    private final SiteCompanycodeMapper baseMapper;

    /**
     * 查询【请填写功能名称】
     */
    @Override
    public SiteCompanycodeVo queryById(String id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 查询【请填写功能名称】列表
     */
    @Override
    public TableDataInfo<SiteCompanycodeVo> queryPageList(SiteCompanycodeBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<SiteCompanycode> lqw = buildQueryWrapper(bo);
        Page<SiteCompanycodeVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询【请填写功能名称】列表
     */
    @Override
    public List<SiteCompanycodeVo> queryList(SiteCompanycodeBo bo) {
        LambdaQueryWrapper<SiteCompanycode> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<SiteCompanycode> buildQueryWrapper(SiteCompanycodeBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<SiteCompanycode> lqw = Wrappers.lambdaQuery();
        lqw.eq(StringUtils.isNotBlank(bo.getShipperCode()), SiteCompanycode::getShipperCode, bo.getShipperCode());
        lqw.eq(StringUtils.isNotBlank(bo.getCompany()), SiteCompanycode::getCompany, bo.getCompany());
        return lqw;
    }

    /**
     * 新增【请填写功能名称】
     */
    @Override
    public Boolean insertByBo(SiteCompanycodeBo bo) {
        SiteCompanycode add = MapstructUtils.convert(bo, SiteCompanycode.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改【请填写功能名称】
     */
    @Override
    public Boolean updateByBo(SiteCompanycodeBo bo) {
        SiteCompanycode update = MapstructUtils.convert(bo, SiteCompanycode.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(SiteCompanycode entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 批量删除【请填写功能名称】
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<String> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteBatchIds(ids) > 0;
    }
}
